#!/usr/bin/env ruby

require 'bio'
require 'uri'
require 'net/http'

# KEGG API ΥФ³ WSDL Ѳǽʥ᥽åɤ
serv = Bio::KEGG::API.new

# ꤷѥ˺ܤäƤ̾ΥꥹȤ
path = ARGV.shift || 'path:eco00010'
genes = serv.get_genes_by_pathway(path)

# LinkDB ѤơưҤ PDB ǡ١ؤΥ󥯤õ
results = Hash.new
genes.each do |gene|
  print gene
  if links = serv.get_linkdb_by_entry(gene, 'pdb')
    # 󥯤С֤˥Υȥ̾ɽ
    links.each do |link|
      results[gene] ||= Array.new
      results[gene] << link.entry_id2
      print "\t" + link.entry_id2
    end
  end
  puts
end

# 󥯤äҤΥꥹȤϤȤ˿դ
url, = serv.mark_pathway_by_genes(path, results.keys)
STDERR.puts url

#  URL ֤Τǡºݤβեե¸
host = URI.parse(url).host
path = URI.parse(url).path

filename = 'pdb_on_' + File.basename(path)

File.open(filename, File::CREAT|File::TRUNC|File::RDWR) do |file|
  file.print Net::HTTP.get_response(host, path).body
end
