#!/usr/bin/env ruby

require 'bio'

reports = Bio::FlatFile.open(Bio::Blast::Default::Report, ARGF)

reports.each do |report|
  print "--- BLAST hits : ", report.db, "\n"
  print "Query = ", report.query_def, "\n"
  report.each do |hit|
    print "Hit = ", hit.definition, "\n"
    hit.each do |hsp|
      if hsp.align_len > 100
        print " Length = ", hsp.align_len, "\n"
        print " E-value = ", hsp.evalue, "\n"
      else
        print " ..skipped..\n"
      end
    end
  end
end
